Imports System.Data.SqlClient

Public Class frmConsultazioneCassaBanca
    Dim _conto As EntiNonCommerciali.Model.Associazione.typeConto = Nothing

    Public Sub New()
        ' Chiamata richiesta da Progettazione Windows Form.
        InitializeComponent()

        ' Aggiungere le eventuali istruzioni di inizializzazione dopo la chiamata a InitializeComponent().
    End Sub

    Dim _formLoading As Boolean = True
    Dim dt As New DataTable
    Dim _tipologiaRicerca As Short = 0
    Dim ds As New DataSet

#Region " Eventi form "
    Private Sub frmConsultazioneCassaBanca_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        'Effettuare il dispose delle variabili del form che non servono pi
        _conto = Nothing
    End Sub

    Private Sub frmConsultazioneCassaBanca_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        'Chiedere conferma della chiusura del form ed eventualmente effettuare il salvataggio
    End Sub

    Private Sub frmConsultazioneCassaBanca_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'Caricamento dei dati
        ucPulsanti.AddButton("btnExcel", "Esporta in Excel")

        Dim StreamXML As IO.StreamReader = New IO.StreamReader(System.Reflection.Assembly.GetExecutingAssembly.GetManifestResourceStream("TestInfragistics.dataset.xml"))
        ds.ReadXml(StreamXML)

        _conto = New EntiNonCommerciali.Model.Associazione.typeConto(ds)
        CreaTabella()

        CaricaDati()

        _formLoading = False
    End Sub

    Private Sub frmConsultazioneCassaBanca_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
        'Gestire qu l'alert per il lock dello user su una riga del db
    End Sub
#End Region

#Region " Eventi Pulsanti "
    Private Sub ubtnRicercaOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ubtnRicercaOK.Click
        CaricaDati()
    End Sub

    Private Sub ubtnRicercaClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ubtnRicercaClear.Click
        uccDataDa.Value = Nothing
        uccDataA.Value = Nothing
        rbTipologia.Value = 0
        CaricaDati()
    End Sub
    Private Sub ucPulsanti_btnChiudi_Click() Handles ucPulsanti.btnChiudi_Click
        Me.Close()
    End Sub

    Private Sub ucPulsanti_btnSalva_Click() Handles ucPulsanti.btnSalva_Click
        Me.DialogResult = Windows.Forms.DialogResult.OK
    End Sub

    Private Sub ucPulsanti_Clicked(ByVal sender As Object, ByVal e As SeritelControls.ucPulsantiera.ClickedEventHandler) Handles ucPulsanti.Clicked
        Select Case e.Button_Name
            Case "btnExcel"
        End Select
    End Sub

#End Region

#Region " Funzioni "
    Private Sub CreaTabella()
        dt.Columns.Add("Data", GetType(System.DateTime))
        dt.Columns.Add("Protocollo")
        dt.Columns.Add("Causale")
        dt.Columns.Add("Imputazione")
        dt.Columns.Add("Descrizione")

        For Each dr As DataRow In _conto.DataTable.Select("", "conto_tipo")
            If dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                dt.Columns.Add("Banca_" & dr("conto_id") & "_E", GetType(System.Double))
                dt.Columns.Add("Banca_" & dr("conto_id") & "_U", GetType(System.Double))
                dt.Columns.Add("Banca_" & dr("conto_id") & "_DLEE", GetType(System.Double))
                dt.Columns.Add("Banca_" & dr("conto_id") & "_DLEU", GetType(System.Double))
                dt.Columns.Add("Banca_" & dr("conto_id") & "_FE", GetType(System.Double))
                dt.Columns.Add("Banca_" & dr("conto_id") & "_FU", GetType(System.Double))
                dt.Columns.Add("Banca_" & dr("conto_id") & "_VPCCE", GetType(System.Double))
                dt.Columns.Add("Banca_" & dr("conto_id") & "_VPCCU", GetType(System.Double))
                dt.Columns.Add("Banca_" & dr("conto_id") & "_Progressivo", GetType(System.Double))
            ElseIf dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                dt.Columns.Add("Cassa_" & dr("conto_id") & "_E", GetType(System.Double))
                dt.Columns.Add("Cassa_" & dr("conto_id") & "_U", GetType(System.Double))
                dt.Columns.Add("Cassa_" & dr("conto_id") & "_DLEE", GetType(System.Double))
                dt.Columns.Add("Cassa_" & dr("conto_id") & "_DLEU", GetType(System.Double))
                dt.Columns.Add("Cassa_" & dr("conto_id") & "_FE", GetType(System.Double))
                dt.Columns.Add("Cassa_" & dr("conto_id") & "_FU", GetType(System.Double))
                dt.Columns.Add("Cassa_" & dr("conto_id") & "_VPCCE", GetType(System.Double))
                dt.Columns.Add("Cassa_" & dr("conto_id") & "_VPCCU", GetType(System.Double))
                dt.Columns.Add("Cassa_" & dr("conto_id") & "_Progressivo", GetType(System.Double))
            End If
        Next
        dt.Columns.Add("TotaleEntrate", GetType(System.Double))
        dt.Columns.Add("TotaleUscite", GetType(System.Double))

        dt.TableName = "TbMovimenti"
    End Sub

    Private Sub CaricaDati()
        _tipologiaRicerca = rbTipologia.Value
        Dim stringaFiltro As String = String.Empty


        Select Case rbTipologia.Value
            Case 1
                'CDF - Prelevamenti c/c            
                stringaFiltro &= IIf(stringaFiltro.Length > 0, " AND ", "") & "(causale_id=" & EntiNonCommerciali.Model.Causale.typeCausale.PRELEVAMENTICC & " OR causale_id=" & EntiNonCommerciali.Model.Causale.typeCausale.VERSAMENTICC & ")"
            Case 2
                'CDF - DLE
                stringaFiltro &= IIf(stringaFiltro.Length > 0, " AND ", "") & "(causale_id=" & EntiNonCommerciali.Model.Causale.typeCausale.DLE_INVESTIMENTI & " OR causale_id=" & EntiNonCommerciali.Model.Causale.typeCausale.DLE_DISINVESTIMENTI & ")"
            Case 3
                'CDF - Entrate/Uscite
                stringaFiltro &= IIf(stringaFiltro.Length > 0, " AND ", "") & "(causale_id=" & EntiNonCommerciali.Model.Causale.typeCausale.ENTRATE & " OR causale_id=" & EntiNonCommerciali.Model.Causale.typeCausale.USCITE & ")"
            Case 4
                'CDF - Finanziamenti
                stringaFiltro &= IIf(stringaFiltro.Length > 0, " AND ", "") & "(causale_id=" & EntiNonCommerciali.Model.Causale.typeCausale.FINANZIAMENTI & " OR causale_id=" & EntiNonCommerciali.Model.Causale.typeCausale.RIMBORSI_FINANZIAMENTI & ")"
        End Select

        If Not SeritelControls.Data.DataVuota(uccDataDa.Value) Then
            Dim DataDa As String = Year(uccDataDa.Value) & "-" & Month(uccDataDa.Value).ToString.PadLeft(2, "0") & "-" & Microsoft.VisualBasic.Day(uccDataDa.Value).ToString.PadLeft(2, "0") & " 00:00:00"
            stringaFiltro &= IIf(stringaFiltro.Length > 0, " AND ", "") & " movimento_data>=CONVERT(DATETIME, '" & DataDa & "', 102)"
        End If
        If Not SeritelControls.Data.DataVuota(uccDataA.Value) Then
            Dim DataA As String = Year(uccDataA.Value) & "-" & Month(uccDataA.Value).ToString.PadLeft(2, "0") & "-" & Microsoft.VisualBasic.Day(uccDataA.Value).ToString.PadLeft(2, "0") & " 23:59:59"
            stringaFiltro &= IIf(stringaFiltro.Length > 0, " AND ", "") & " movimento_data<=CONVERT(DATETIME, '" & DataA & "', 102)"
        End If

        If stringaFiltro.Length > 0 Then stringaFiltro = "WHERE " & stringaFiltro

        Dim dtRighe As New DataTable
        dtRighe = ds.Tables("TbMovimenti").Copy

        dt.Rows.Clear()
        For Each row As DataRow In dtRighe.Rows
            Dim newRow As DataRow = dt.NewRow

            newRow("Data") = row("movimento_data")
            newRow("Protocollo") = row("movimento_protocollo")
            newRow("Causale") = row("causale_descrizione")
            newRow("Imputazione") = row("imp_descrizione")
            newRow("Descrizione") = row("movimento_descrizione")

            For Each dr As DataRow In _conto.DataTable.Select("", "conto_tipo")
                If dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                    If dt.Rows.Count = 0 Then
                        newRow("Banca_" & dr("conto_id") & "_Progressivo") = 0
                    Else
                        newRow("Banca_" & dr("conto_id") & "_Progressivo") = dt.Rows(dt.Rows.Count - 1)("Banca_" & dr("conto_id") & "_Progressivo")
                    End If
                ElseIf dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                    If dt.Rows.Count = 0 Then
                        newRow("Cassa_" & dr("conto_id") & "_Progressivo") = 0
                    Else
                        newRow("Cassa_" & dr("conto_id") & "_Progressivo") = dt.Rows(dt.Rows.Count - 1)("Cassa_" & dr("conto_id") & "_Progressivo")
                    End If
                End If
            Next

            Select Case row("causale_id")
                Case EntiNonCommerciali.Model.Causale.typeCausale.ENTRATE, EntiNonCommerciali.Model.Causale.typeCausale.USCITE
                    If row("causale_id") = EntiNonCommerciali.Model.Causale.typeCausale.ENTRATE Then
                        If _conto.Seleziona(row("riga_conto1")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                            newRow("Banca_" & row("riga_conto1") & "_E") = row("riga_importo")
                            newRow("Banca_" & row("riga_conto1") & "_Progressivo") += row("riga_importo")
                        ElseIf _conto.Seleziona(row("riga_conto1")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                            newRow("Cassa_" & row("riga_conto1") & "_E") = row("riga_importo")
                            newRow("Cassa_" & row("riga_conto1") & "_Progressivo") += row("riga_importo")
                        End If
                        newRow("TotaleEntrate") = row("riga_importo")
                    Else
                        If _conto.Seleziona(row("riga_conto1")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                            newRow("Banca_" & row("riga_conto1") & "_U") = row("riga_importo")
                            newRow("Banca_" & row("riga_conto1") & "_Progressivo") -= row("riga_importo")
                        ElseIf _conto.Seleziona(row("riga_conto1")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                            newRow("Cassa_" & row("riga_conto1") & "_U") = row("riga_importo")
                            newRow("Cassa_" & row("riga_conto1") & "_Progressivo") -= row("riga_importo")
                        End If
                        newRow("TotaleUscite") = row("riga_importo")
                    End If
                Case EntiNonCommerciali.Model.Causale.typeCausale.PRELEVAMENTICC, EntiNonCommerciali.Model.Causale.typeCausale.VERSAMENTICC
                    If row("causale_id") = EntiNonCommerciali.Model.Causale.typeCausale.PRELEVAMENTICC Then
                        If _conto.Seleziona(row("riga_conto1")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                            newRow("Banca_" & row("riga_conto1") & "_VPCCU") = row("riga_importo")
                            newRow("Banca_" & row("riga_conto1") & "_Progressivo") -= row("riga_importo")
                            newRow("TotaleUscite") = row("riga_importo")
                        ElseIf _conto.Seleziona(row("riga_conto1")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                            newRow("Cassa_" & row("riga_conto1") & "_VPCCU") = row("riga_importo")
                            newRow("Cassa_" & row("riga_conto1") & "_Progressivo") -= row("riga_importo")
                            newRow("TotaleUscite") = row("riga_importo")
                        End If
                        If _conto.Seleziona(row("riga_conto2")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                            newRow("Banca_" & row("riga_conto2") & "_VPCCE") = row("riga_importo")
                            newRow("Banca_" & row("riga_conto2") & "_Progressivo") += row("riga_importo")
                            newRow("TotaleEntrate") = row("riga_importo")
                        ElseIf _conto.Seleziona(row("riga_conto2")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                            newRow("Cassa_" & row("riga_conto2") & "_VPCCE") = row("riga_importo")
                            newRow("Cassa_" & row("riga_conto2") & "_Progressivo") += row("riga_importo")
                            newRow("TotaleEntrate") = row("riga_importo")
                        End If
                    Else
                        If _conto.Seleziona(row("riga_conto1")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                            newRow("Banca_" & row("riga_conto1") & "_VPCCE") = row("riga_importo")
                            newRow("Banca_" & row("riga_conto1") & "_Progressivo") += row("riga_importo")
                            newRow("TotaleEntrate") = row("riga_importo")
                        ElseIf _conto.Seleziona(row("riga_conto1")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                            newRow("Cassa_" & row("riga_conto1") & "_VPCCE") = row("riga_importo")
                            newRow("Cassa_" & row("riga_conto1") & "_Progressivo") += row("riga_importo")
                            newRow("TotaleEntrate") = row("riga_importo")
                        End If
                        If _conto.Seleziona(row("riga_conto2")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                            newRow("Banca_" & row("riga_conto2") & "_VPCCU") = row("riga_importo")
                            newRow("Banca_" & row("riga_conto2") & "_Progressivo") -= row("riga_importo")
                            newRow("TotaleUscite") = row("riga_importo")
                        ElseIf _conto.Seleziona(row("riga_conto2")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                            newRow("Cassa_" & row("riga_conto2") & "_VPCCU") = row("riga_importo")
                            newRow("Cassa_" & row("riga_conto2") & "_Progressivo") -= row("riga_importo")
                            newRow("TotaleUscite") = row("riga_importo")
                        End If
                    End If
                Case EntiNonCommerciali.Model.Causale.typeCausale.DLE_INVESTIMENTI, EntiNonCommerciali.Model.Causale.typeCausale.DLE_DISINVESTIMENTI
                    If row("causale_id") = EntiNonCommerciali.Model.Causale.typeCausale.DLE_DISINVESTIMENTI Then
                        If _conto.Seleziona(row("riga_conto1")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                            newRow("Banca_" & row("riga_conto1") & "_DLEE") = row("riga_importo")
                            newRow("Banca_" & row("riga_conto1") & "_Progressivo") += row("riga_importo")
                        ElseIf _conto.Seleziona(row("riga_conto1")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                            newRow("Cassa_" & row("riga_conto1") & "_DLEE") = row("riga_importo")
                            newRow("Cassa_" & row("riga_conto1") & "_Progressivo") += row("riga_importo")
                        End If
                        newRow("TotaleEntrate") = row("riga_importo")
                    Else
                        If _conto.Seleziona(row("riga_conto1")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                            newRow("Banca_" & row("riga_conto1") & "_DLEU") = row("riga_importo")
                            newRow("Banca_" & row("riga_conto1") & "_Progressivo") -= row("riga_importo")
                        ElseIf _conto.Seleziona(row("riga_conto1")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                            newRow("Cassa_" & row("riga_conto1") & "_DLEU") = row("riga_importo")
                            newRow("Cassa_" & row("riga_conto1") & "_Progressivo") -= row("riga_importo")
                        End If
                        newRow("TotaleUscite") = row("riga_importo")
                    End If
                Case EntiNonCommerciali.Model.Causale.typeCausale.FINANZIAMENTI, EntiNonCommerciali.Model.Causale.typeCausale.RIMBORSI_FINANZIAMENTI
                    If row("causale_id") = EntiNonCommerciali.Model.Causale.typeCausale.FINANZIAMENTI Then
                        If _conto.Seleziona(row("riga_conto1")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                            newRow("Banca_" & row("riga_conto1") & "_FE") = row("riga_importo")
                            newRow("Banca_" & row("riga_conto1") & "_Progressivo") += row("riga_importo")
                        ElseIf _conto.Seleziona(row("riga_conto1")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                            newRow("Cassa_" & row("riga_conto1") & "_FE") = row("riga_importo")
                            newRow("Cassa_" & row("riga_conto1") & "_Progressivo") += row("riga_importo")
                        End If
                        newRow("TotaleEntrate") = row("riga_importo")
                    Else
                        If _conto.Seleziona(row("riga_conto1")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                            newRow("Banca_" & row("riga_conto1") & "_FU") = row("riga_importo")
                            newRow("Banca_" & row("riga_conto1") & "_Progressivo") -= row("riga_importo")
                        ElseIf _conto.Seleziona(row("riga_conto1")).Tipo = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                            newRow("Cassa_" & row("riga_conto1") & "_FU") = row("riga_importo")
                            newRow("Cassa_" & row("riga_conto1") & "_Progressivo") -= row("riga_importo")
                        End If
                        newRow("TotaleUscite") = row("riga_importo")
                    End If
            End Select


            dt.Rows.Add(newRow)
        Next

        ugrDettaglio.DataSource = dt

        Dim band As Infragistics.Win.UltraWinGrid.UltraGridBand = ugrDettaglio.DisplayLayout.Bands(0)
        band.RowLayoutStyle = Infragistics.Win.UltraWinGrid.RowLayoutStyle.GroupLayout
        band.RowLayouts.Clear()
        ugrDettaglio.DisplayLayout.Bands(0).Groups.Clear()

        Dim OrdineColonna As Integer = 0
        Dim colonna As Infragistics.Win.UltraWinGrid.UltraGridColumn = Nothing

        AggiungiColonna("Data", OrdineColonna, 0, 1, 3, 70)
        AggiungiColonna("Protocollo", OrdineColonna, 0, 1, 3, 70)
        AggiungiColonna("Causale", OrdineColonna, 0, 1, 3, 120)
        AggiungiColonna("Imputazione", OrdineColonna, 0, 1, 3, 140)
        AggiungiColonna("Descrizione", OrdineColonna, 0, 1, 3, 140)

        Dim indice As Integer = 0

        Dim gruppoEntrateUscite As Infragistics.Win.UltraWinGrid.UltraGridGroup = AggiungiGruppo("Entrate/Uscite", OrdineColonna, 0, _conto.DataTable.Rows.Count * 2, 1)

        Dim gruppoEntrateUscite_E As Infragistics.Win.UltraWinGrid.UltraGridGroup = AggiungiGruppo("Entrate", 0, 0, _conto.DataTable.Rows.Count, 1, gruppoEntrateUscite)
        indice = 0
        For Each dr As DataRow In _conto.DataTable.Select("", "conto_tipo")
            If dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                colonna = AggiungiColonna("Banca_" & dr("conto_id") & "_E", indice, 0, 1, 1, 90, gruppoEntrateUscite_E)
            ElseIf dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                colonna = AggiungiColonna("Cassa_" & dr("conto_id") & "_E", indice, 0, 1, 1, 90, gruppoEntrateUscite_E)
            End If

            colonna.Header.Caption = dr("conto_descrizione")
            colonna.CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right
            colonna.Format = FORMAT_NUMERI_2_DECIMALI
        Next
        Dim gruppoEntrateUscite_U As Infragistics.Win.UltraWinGrid.UltraGridGroup = AggiungiGruppo("Uscite", _conto.DataTable.Rows.Count, 0, _conto.DataTable.Rows.Count, 1, gruppoEntrateUscite)
        indice = 0
        For Each dr As DataRow In _conto.DataTable.Select("", "conto_tipo")
            If dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                colonna = AggiungiColonna("Banca_" & dr("conto_id") & "_U", indice, 0, 1, 1, 90, gruppoEntrateUscite_U)
            ElseIf dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                colonna = AggiungiColonna("Cassa_" & dr("conto_id") & "_U", indice, 0, 1, 1, 90, gruppoEntrateUscite_U)
            End If

            colonna.Header.Caption = dr("conto_descrizione")
            colonna.CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right
            colonna.Format = FORMAT_NUMERI_2_DECIMALI
        Next

        OrdineColonna += _conto.DataTable.Rows.Count * 2

        Dim gruppoEntrateUsciteDLE As Infragistics.Win.UltraWinGrid.UltraGridGroup = AggiungiGruppo("Disponibilit liquide equivalenti", OrdineColonna, 0, _conto.DataTable.Rows.Count * 2, 1)

        Dim gruppoEntrateUscite_DLEE As Infragistics.Win.UltraWinGrid.UltraGridGroup = AggiungiGruppo("Entrate per disinvestimenti", 0, 0, _conto.DataTable.Rows.Count, 1, gruppoEntrateUsciteDLE)
        indice = 0
        For Each dr As DataRow In _conto.DataTable.Select("", "conto_tipo")
            If dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                colonna = AggiungiColonna("Banca_" & dr("conto_id") & "_DLEE", indice, 0, 1, 1, 90, gruppoEntrateUscite_DLEE)
            ElseIf dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                colonna = AggiungiColonna("Cassa_" & dr("conto_id") & "_DLEE", indice, 0, 1, 1, 90, gruppoEntrateUscite_DLEE)
            End If

            colonna.Header.Caption = dr("conto_descrizione")
            colonna.CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right
            colonna.Format = FORMAT_NUMERI_2_DECIMALI
        Next
        Dim gruppoEntrateUscite_DLEU As Infragistics.Win.UltraWinGrid.UltraGridGroup = AggiungiGruppo("Uscite per investimenti", _conto.DataTable.Rows.Count, 0, _conto.DataTable.Rows.Count, 1, gruppoEntrateUsciteDLE)
        indice = 0
        For Each dr As DataRow In _conto.DataTable.Select("", "conto_tipo")
            If dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                colonna = AggiungiColonna("Banca_" & dr("conto_id") & "_DLEU", indice, 0, 1, 1, 90, gruppoEntrateUscite_DLEU)
            ElseIf dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                colonna = AggiungiColonna("Cassa_" & dr("conto_id") & "_DLEU", indice, 0, 1, 1, 90, gruppoEntrateUscite_DLEU)
            End If

            colonna.Header.Caption = dr("conto_descrizione")
            colonna.CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right
            colonna.Format = FORMAT_NUMERI_2_DECIMALI
        Next

        OrdineColonna += _conto.DataTable.Rows.Count * 2

        Dim gruppoEntrateUsciteF As Infragistics.Win.UltraWinGrid.UltraGridGroup = AggiungiGruppo("Finanziamenti", OrdineColonna, 0, _conto.DataTable.Rows.Count * 2, 1)

        Dim gruppoEntrateUscite_FE As Infragistics.Win.UltraWinGrid.UltraGridGroup = AggiungiGruppo("Entrate per incassi", 0, 0, _conto.DataTable.Rows.Count, 1, gruppoEntrateUsciteF)
        indice = 0
        For Each dr As DataRow In _conto.DataTable.Select("", "conto_tipo")
            If dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                colonna = AggiungiColonna("Banca_" & dr("conto_id") & "_FE", indice, 0, 1, 1, 90, gruppoEntrateUscite_FE)
            ElseIf dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                colonna = AggiungiColonna("Cassa_" & dr("conto_id") & "_FE", indice, 0, 1, 1, 90, gruppoEntrateUscite_FE)
            End If

            colonna.Header.Caption = dr("conto_descrizione")
            colonna.CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right
            colonna.Format = FORMAT_NUMERI_2_DECIMALI
        Next
        Dim gruppoEntrateUscite_FU As Infragistics.Win.UltraWinGrid.UltraGridGroup = AggiungiGruppo("Uscite per rimborsi", _conto.DataTable.Rows.Count, 0, _conto.DataTable.Rows.Count, 1, gruppoEntrateUsciteF)
        indice = 0
        For Each dr As DataRow In _conto.DataTable.Select("", "conto_tipo")
            If dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                colonna = AggiungiColonna("Banca_" & dr("conto_id") & "_FU", indice, 0, 1, 1, 90, gruppoEntrateUscite_FU)
            ElseIf dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                colonna = AggiungiColonna("Cassa_" & dr("conto_id") & "_FU", indice, 0, 1, 1, 90, gruppoEntrateUscite_FU)
            End If

            colonna.Header.Caption = dr("conto_descrizione")
            colonna.CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right
            colonna.Format = FORMAT_NUMERI_2_DECIMALI
        Next

        OrdineColonna += _conto.DataTable.Rows.Count * 2

        Dim gruppoEntrateUsciteVP As Infragistics.Win.UltraWinGrid.UltraGridGroup = AggiungiGruppo("Versamenti dalla cassa sul c/c e prelevamenti dal c/c", OrdineColonna, 0, _conto.DataTable.Rows.Count * 2, 1)

        Dim gruppoEntrateUscite_VPE As Infragistics.Win.UltraWinGrid.UltraGridGroup = AggiungiGruppo("Entrate c/c", 0, 0, _conto.DataTable.Rows.Count, 1, gruppoEntrateUsciteVP)
        indice = 0
        For Each dr As DataRow In _conto.DataTable.Select("", "conto_tipo")
            If dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                colonna = AggiungiColonna("Banca_" & dr("conto_id") & "_VPCCE", indice, 0, 1, 1, 90, gruppoEntrateUscite_VPE)
            ElseIf dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                colonna = AggiungiColonna("Cassa_" & dr("conto_id") & "_VPCCE", indice, 0, 1, 1, 90, gruppoEntrateUscite_VPE)
            End If

            colonna.Header.Caption = dr("conto_descrizione")
            colonna.CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right
            colonna.Format = FORMAT_NUMERI_2_DECIMALI
        Next
        Dim gruppoEntrateUscite_VPU As Infragistics.Win.UltraWinGrid.UltraGridGroup = AggiungiGruppo("Uscite c/c", _conto.DataTable.Rows.Count, 0, _conto.DataTable.Rows.Count, 1, gruppoEntrateUsciteVP)
        indice = 0
        For Each dr As DataRow In _conto.DataTable.Select("", "conto_tipo")
            If dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                colonna = AggiungiColonna("Banca_" & dr("conto_id") & "_VPCCU", indice, 0, 1, 1, 90, gruppoEntrateUscite_VPU)
            ElseIf dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                colonna = AggiungiColonna("Cassa_" & dr("conto_id") & "_VPCCU", indice, 0, 1, 1, 90, gruppoEntrateUscite_VPU)
            End If

            colonna.Header.Caption = dr("conto_descrizione")
            colonna.CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right
            colonna.Format = FORMAT_NUMERI_2_DECIMALI
        Next

        OrdineColonna += _conto.DataTable.Rows.Count * 2

        Dim gruppoTotaliEntrateUscite As Infragistics.Win.UltraWinGrid.UltraGridGroup = AggiungiGruppo("Totali", OrdineColonna, 0, 2, 1)
        colonna = AggiungiColonna("TotaleEntrate", 0, 0, 1, 2, 90, gruppoTotaliEntrateUscite)
        colonna.Header.Caption = "Entrate"
        colonna.CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right
        colonna.Format = FORMAT_NUMERI_2_DECIMALI
        colonna = AggiungiColonna("TotaleUscite", 1, 0, 1, 2, 90, gruppoTotaliEntrateUscite)
        colonna.Header.Caption = "Uscite"
        colonna.CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right
        colonna.Format = FORMAT_NUMERI_2_DECIMALI

        OrdineColonna += 2
        Dim gruppoProgressivi As Infragistics.Win.UltraWinGrid.UltraGridGroup = AggiungiGruppo("Liquidit Progressivi", OrdineColonna, 0, 2, 1)
        indice = 0
        For Each dr As DataRow In _conto.DataTable.Select("", "conto_tipo")
            If dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.BANCA Then
                colonna = AggiungiColonna("Banca_" & dr("conto_id") & "_Progressivo", indice, 0, 1, 2, 90, gruppoProgressivi)
            ElseIf dr("conto_tipo") = EntiNonCommerciali.Model.Associazione.typeConto.CASSA Then
                colonna = AggiungiColonna("Cassa_" & dr("conto_id") & "_Progressivo", indice, 0, 1, 2, 90, gruppoProgressivi)
            End If

            colonna.Header.Caption = dr("conto_descrizione")
            colonna.CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right
            colonna.Format = FORMAT_NUMERI_2_DECIMALI
        Next


        Select Case rbTipologia.Value
            Case 1
                'CDF - Prelevamenti c/c
                gruppoEntrateUscite.Hidden = True
                gruppoEntrateUsciteF.Hidden = True
                gruppoEntrateUsciteDLE.Hidden = True
            Case 2
                'CDF - DLE
                gruppoEntrateUsciteVP.Hidden = True
                gruppoEntrateUscite.Hidden = True
                gruppoEntrateUsciteF.Hidden = True
            Case 3
                'CDF - Entrate/Uscite
                gruppoEntrateUsciteVP.Hidden = True
                gruppoEntrateUsciteDLE.Hidden = True
                gruppoEntrateUsciteF.Hidden = True
            Case 4
                'CDF - Finanziamenti
                gruppoEntrateUsciteVP.Hidden = True
                gruppoEntrateUsciteDLE.Hidden = True
                gruppoEntrateUscite.Hidden = True
        End Select
        ugrDettaglio.DisplayLayout.Bands(0).Columns("Data").CellActivation = Infragistics.Win.UltraWinGrid.Activation.NoEdit
        ugrDettaglio.DataBind()

        RigaTotale()
    End Sub

    Private Function AggiungiColonna(ByVal nomeColonna As String, ByRef originX As Integer, ByVal originY As Integer, ByVal spanX As Integer, ByVal spanY As Integer, ByVal larghezza As Integer, Optional ByVal gruppo As Infragistics.Win.UltraWinGrid.UltraGridGroup = Nothing) As Infragistics.Win.UltraWinGrid.UltraGridColumn
        Dim colonna As Infragistics.Win.UltraWinGrid.UltraGridColumn = ugrDettaglio.DisplayLayout.Bands(0).Columns(nomeColonna)
        colonna.RowLayoutColumnInfo.Initialize(originX, originY, spanX, spanY, larghezza, 0)

        If Not IsNothing(gruppo) Then colonna.RowLayoutColumnInfo.ParentGroup = gruppo
        originX += 1

        Return colonna
    End Function

    Private Function AggiungiGruppo(ByVal nomeGruppo As String, ByVal originX As Integer, ByVal originY As Integer, ByVal spanX As Integer, ByVal spanY As Integer, Optional ByVal gruppoPadre As Infragistics.Win.UltraWinGrid.UltraGridGroup = Nothing) As Infragistics.Win.UltraWinGrid.UltraGridGroup
        Dim gruppo As New Infragistics.Win.UltraWinGrid.UltraGridGroup
        gruppo.Key = nomeGruppo
        gruppo.RowLayoutGroupInfo.Initialize(originX, originY, spanX, spanY)
        ugrDettaglio.DisplayLayout.Bands(0).Groups.Add(gruppo)

        If Not IsNothing(gruppoPadre) Then gruppo.RowLayoutGroupInfo.ParentGroup = gruppoPadre

        Return gruppo
    End Function

    Private Sub RigaTotale()
        If ugrDettaglio.DisplayLayout.Bands(0).Summaries.Exists("SummaryImporto") AndAlso ugrDettaglio.Rows.Count = 0 Then
            'non ci sono righe e il summary  presente allora lo elimino
            ugrDettaglio.DisplayLayout.Bands(0).Summaries.Remove(ugrDettaglio.DisplayLayout.Bands(0).Summaries("SummaryImporto"))
            ugrDettaglio.DisplayLayout.Bands(0).Summaries.Remove(ugrDettaglio.DisplayLayout.Bands(0).Summaries("SummaryImportoIE"))
            ugrDettaglio.DisplayLayout.Bands(0).Summaries.Remove(ugrDettaglio.DisplayLayout.Bands(0).Summaries("SummaryImportoMDCE"))
            ugrDettaglio.DisplayLayout.Bands(0).Summaries.Remove(ugrDettaglio.DisplayLayout.Bands(0).Summaries("SummaryImportoCE"))
            ugrDettaglio.DisplayLayout.Bands(0).Summaries.Remove(ugrDettaglio.DisplayLayout.Bands(0).Summaries("SummaryImportoIU"))
            ugrDettaglio.DisplayLayout.Bands(0).Summaries.Remove(ugrDettaglio.DisplayLayout.Bands(0).Summaries("SummaryImportoMDCU"))
            ugrDettaglio.DisplayLayout.Bands(0).Summaries.Remove(ugrDettaglio.DisplayLayout.Bands(0).Summaries("SummaryImportoCU"))
            ugrDettaglio.DisplayLayout.Bands(0).Summaries.Remove(ugrDettaglio.DisplayLayout.Bands(0).Summaries("SummaryImportoPU"))
        ElseIf Not ugrDettaglio.DisplayLayout.Bands(0).Summaries.Exists("SummaryImporto") AndAlso ugrDettaglio.Rows.Count > 0 Then
            'non c' il summary e ci sono righe allora lo aggiungo
            With ugrDettaglio.DisplayLayout.Bands(0).Summaries.Add("SummaryImporto", Infragistics.Win.UltraWinGrid.SummaryType.Formula, ugrDettaglio.DisplayLayout.Bands(0).Columns("Descrizione"))
                .DisplayFormat = "Totali:"
                .Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True
                .Appearance.TextHAlign = Infragistics.Win.HAlign.Right
                .SummaryPosition = Infragistics.Win.UltraWinGrid.SummaryPosition.UseSummaryPositionColumn
            End With

            For Each dc As DataColumn In dt.Columns
                If (dc.ColumnName.StartsWith("Banca") OrElse dc.ColumnName.StartsWith("Cassa")) AndAlso Not dc.ColumnName.EndsWith("Progressivo") Then
                    With ugrDettaglio.DisplayLayout.Bands(0).Summaries.Add("SummaryImporto_" & dc.ColumnName, Infragistics.Win.UltraWinGrid.SummaryType.Sum, ugrDettaglio.DisplayLayout.Bands(0).Columns(dc.ColumnName))
                        .DisplayFormat = "{0:#,##0.00}"
                        .Appearance.TextHAlign = Infragistics.Win.HAlign.Right
                        .SummaryPosition = Infragistics.Win.UltraWinGrid.SummaryPosition.UseSummaryPositionColumn
                    End With
                End If
            Next

            With ugrDettaglio.DisplayLayout.Bands(0).Summaries.Add("SummaryImporto_TotaleEntrate", Infragistics.Win.UltraWinGrid.SummaryType.Sum, ugrDettaglio.DisplayLayout.Bands(0).Columns("TotaleEntrate"))
                .DisplayFormat = "{0:#,##0.00}"
                .Appearance.TextHAlign = Infragistics.Win.HAlign.Right
                .SummaryPosition = Infragistics.Win.UltraWinGrid.SummaryPosition.UseSummaryPositionColumn
            End With
            With ugrDettaglio.DisplayLayout.Bands(0).Summaries.Add("SummaryImporto_TotaleUscite", Infragistics.Win.UltraWinGrid.SummaryType.Sum, ugrDettaglio.DisplayLayout.Bands(0).Columns("TotaleUscite"))
                .DisplayFormat = "{0:#,##0.00}"
                .Appearance.TextHAlign = Infragistics.Win.HAlign.Right
                .SummaryPosition = Infragistics.Win.UltraWinGrid.SummaryPosition.UseSummaryPositionColumn
            End With

        End If
    End Sub
#End Region

#Region " Eventi Controlli "

#End Region


End Class
